//  OptionsWindow.cpp
//  Copyright (C)  1997 Kenneth N. Flaxman (knf@kenlaw.com)
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2, or (at your option)
//   any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

#include "OptionsWindow.h"


OptionsWindow::OptionsWindow(BeDaliClockView *view, bool armyFlag, bool buttonOneFlag)	:
		BWindow(BRect(50,60,50+300,60+140), "BeDaliClock Settings",
                          B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE ,
                          B_CURRENT_WORKSPACE)          
{
	BRect R = Bounds();
	mainView = new BView(R, "prefs", B_FOLLOW_ALL, B_WILL_DRAW);
	mainView->SetViewColor(216, 216, 216);	// gray
	AddChild(mainView);
	view->SetOptionsWindowFlag(true);
	myView = view;
	
	cb[0] = new BCheckBox(BRect(13,15,R.right-10,25),
								   "armytime", "Show 24 hour time",
								   new BMessage(ARMY) );
	cb[0]->SetValue(armyFlag);		//make checked						   
	cb[0]->SetTarget(this);
	mainView->AddChild(cb[0]);
	cb[1] = new BCheckBox(BRect(13,30,Bounds().right-10,30),
						   "showdate", "Button 1 Shows Date",
								   new BMessage(BTN1_DATE) );
	cb[1]->SetValue(buttonOneFlag);		//make checked								   
	cb[1]->SetTarget(this);
	mainView->AddChild(cb[1]);
	
	//menu colors
	ColorLabel = new BStringView(BRect(13.0, 60.0 ,R.right-10.0,78.0),
					"Label2", "Color of Numbers");
	ColorLabel->SetFontSize(12.0);
	mainView->AddChild(ColorLabel);
	menuBar = new BMenuBar(BRect(20.0,80.0,13.0 + 90.0, 95.0), "menuBar",0, B_ITEMS_IN_ROW, true);
	menuBar->SetBorder(B_BORDER_CONTENTS);
	popupMenu = new BPopUpMenu("popupMenu", true, true, B_ITEMS_IN_COLUMN);
	popupMenu->SetTargetForItems(this);
	const char *colornames[] = {"White", "CadetBlue", "DarkKhaki", 
								"DeepPink", "Red", "Lavender", "Magenta",
								"Orange", "snow", "Yellow"};
	Nel = sizeof(colornames) / sizeof(char *);
	for (int i = 0; i < Nel; i++)	{
		mi[i] = new BMenuItem(colornames[i] ,new BMessage(COLORS));
		popupMenu->AddItem(mi[i]);
		mi[0]->SetTarget(this);
		if (strcmp(colornames[i], myView->GetNumberColor()) == 0)
			mi[i]->SetMarked(true);
	}	
	
	
	
	//BMenuItem *mitem = new BMenuItem("Blue", new BMessage(COLORS) );
	//mitem->SetTarget(this);
	//popupMenu->AddItem(new BMenuItem("Blue", new BMessage (COLORS)) );
//	
//	popupMenu->AddItem(new BMenuItem("Yellow",new BMessage(COLORS) ));
	menuBar->AddItem(popupMenu);
	mainView->AddChild(menuBar);
	Label = new BStringView(BRect(25.0, R.bottom - 15, R.right-10.0,R.bottom - 2.0),
					"Label", "BeDaliClock (c) 1997 AbiSoft bedev@kenlaw.com");
	mainView->AddChild(Label);
	
}
OptionsWindow::OptionsWindow(BMessage *data)
{
	
}
OptionsWindow::~OptionsWindow()
{
}
bool
OptionsWindow::QuitRequested()
{
	myView->SetOptionsWindowFlag(false);
	return true;
}
void
OptionsWindow::MoveToAndShow(float x, float y)
{
	MoveTo(x, y);
	Show();
	
}
void
OptionsWindow::MessageReceived(BMessage *msg)
{
	switch	(msg->what)	{
		case ARMY:
			myView->SetArmyTime(cb[0]->Value() );
			break;
		case BTN1_DATE:
			myView->SetButtonOneShowsDate(cb[1]->Value() );
			break;	
		case COLORS:	
			for (int i = 0; i < Nel; i++)	{
				if(mi[i]->IsMarked())	{
					myView->SetNumberColor(mi[i]->Label() );
					break;
				}
			}
			break;
		case B_ABOUT_REQUESTED:
			AboutRequested();
			break;
		default:
			break;
	}
}
void
OptionsWindow::AboutRequested()
{
}