//  OptionsWindow.h
//   Copyright (C)  1997 Kenneth N. Flaxman (knf@kenlaw.com)
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2, or (at your option)
//   any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

#pragma once
#include <Window.h>
#pragma export on
#include "BeDaliClockView.h"
#include <StringView.h>
#include <Button.h>
#include <StatusBar.h>
class BeDaliClockView;
class OptionsWindow : public BWindow
{
	enum {ARMY = 'army', BTN1_DATE = 'btn1', COLORS = 'colo'};
public:
	OptionsWindow(BeDaliClockView *, bool armyFlag = true, bool but1flag = true);
	OptionsWindow(BMessage *data);
	~OptionsWindow();
	virtual bool QuitRequested();
	void	MoveToAndShow(float x, float y);
	void	MessageReceived(BMessage *msg);
	void	AboutRequested();
private:
	BeDaliClockView	*myView;	
	BView	*mainView;
	BStringView	*Label, *ColorLabel;
	BMenuBar	*menuBar;
	BPopUpMenu *popupMenu;
	BMenuItem *mi[20];	//maximum of colors
	BCheckBox *cb[2];
	int Nel;	//actuan number of colors
};
#pragma export off